#include <windows.h>
#include "nh.h"

typedef struct
{
	char str[1024-sizeof(bool)];
	bool IsWait;
} SENDNHARUNADATA, *LPSENDNHARUNADATA;

static DWORD WINAPI _MKSendNHaruna_Thread( LPSENDNHARUNADATA lpSnhd )
{
#ifdef _WIN32
    static const char MutexName[] = "_nesterJ_SendNHaruna_Mutex_";
	static sockaddr_in addr = 
	{
		AF_INET,
		htons(11000),
		{0x7F,0x00,0x00,0x01}
	};

	WSADATA wsd;
	SOCKET s;
    HANDLE hMutex;
	
	hMutex = CreateMutex( NULL, FALSE, MutexName );
	if( WaitForSingleObject( hMutex, ( lpSnhd->IsWait ) ? INFINITE : 1000 ) != WAIT_TIMEOUT )
	{
		if( !WSAStartup( MAKEWORD(1,1), &wsd ) )
		{
			if( ( s = socket( AF_INET, SOCK_STREAM, 0 ) ) != INVALID_SOCKET )
			{
				if( !connect( s, (sockaddr*)&addr, sizeof(sockaddr) ) )
				{
					send( s, lpSnhd->str, lstrlen( lpSnhd->str ), 0 );
				}
				closesocket(s);
			}
			WSACleanup();
		}
		ReleaseMutex( hMutex );
	}
#endif // _WIN32
	return 0;
}

static const char NHarunaMutexName[] = "sakura";

bool __stdcall MKRequestNHaruna( const char *str, bool IsWait )
{
#ifdef _WIN32
	static SENDNHARUNADATA snhd;
	HANDLE hNHarunaMutex;
	if( !( hNHarunaMutex = OpenMutex( MUTEX_ALL_ACCESS, FALSE, NHarunaMutexName ) ) )
		return false;
	
	CloseHandle( hNHarunaMutex );
	
	strcpy( snhd.str, str );
	snhd.IsWait = IsWait;
   	
	HANDLE hThread;
	snhd.IsWait = IsWait;
	hThread = CreateThread( NULL, 512, (LPTHREAD_START_ROUTINE)_MKSendNHaruna_Thread, &snhd, 0, NULL );
	if( IsWait )
	{
		WaitForSingleObject( hThread, INFINITE );
		hThread = NULL;
	}
    return true;
#else
	return false;
#endif
}

bool __stdcall MKSendNHaruna( const char *str, bool IsWait )
{
#ifdef _WIN32
	static SENDNHARUNADATA snhd = 
	{
		"SEND SSTP/1.0\r\n" \
		"Sender: nesterJ\r\n" \
		"Script: "
	};
	static const int length = strlen(snhd.str);
	
	HANDLE hNHarunaMutex;
	if( !( hNHarunaMutex = OpenMutex( MUTEX_ALL_ACCESS, FALSE, NHarunaMutexName ) ) )
		return false;
	
	CloseHandle( hNHarunaMutex );
	
	snhd.str[length] = '\0';
	
	int p1, p2;
	p1 = 0; p2 = length;
	while(true)
	{
		if( IsDBCSLeadByte( str[p1] ) )
		{
			snhd.str[p2++] = str[p1++];
		}
		else
		{
			switch(str[p1])
			{
			case '\r':
				p1++;
			case '\\':
				snhd.str[p2++] = '\\';
				break;
			case '\n':
				p1++;
				snhd.str[p2++] = '\\';
				snhd.str[p2++] = 'n';
				continue;
			}
		}
		if( !( snhd.str[p2++] = str[p1++] ) )
			break;
	}
	strcat( snhd.str, "\\e\r\n\r\n" );
	
   	HANDLE hThread;
	snhd.IsWait = IsWait;
	DWORD ThreadId;
	hThread = CreateThread( NULL, 0x200, (LPTHREAD_START_ROUTINE)_MKSendNHaruna_Thread, &snhd, 0, &ThreadId );
	if( IsWait )
	{
		WaitForSingleObject( hThread, INFINITE );
		hThread = NULL;
	}
	return true;
#else
	return false;
#endif // _WIN32
}
