/*
** nester - NES emulator
** Copyright (C) 2000  Darren Ranalli
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful, 
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU 
** Library General Public License for more details.  To obtain a 
** copy of the GNU Library General Public License, write to the Free 
** Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
**
** Any permitted reproduction of these routines, in whole or in part,
** must bear this legend.
*/

#include "win32_default_controls.h"
#include "OSD_ButtonSettings.h"

static OSD_ButtonSettings Key_Up(OSD_ButtonSettings::KEYBOARD_KEY, WIN32_DEFAULT_UP_KEY);
static OSD_ButtonSettings Key_Down(OSD_ButtonSettings::KEYBOARD_KEY, WIN32_DEFAULT_DOWN_KEY);
static OSD_ButtonSettings Key_Left(OSD_ButtonSettings::KEYBOARD_KEY, WIN32_DEFAULT_LEFT_KEY);
static OSD_ButtonSettings Key_Right(OSD_ButtonSettings::KEYBOARD_KEY, WIN32_DEFAULT_RIGHT_KEY);
static OSD_ButtonSettings Key_Select(OSD_ButtonSettings::KEYBOARD_KEY, WIN32_DEFAULT_SELECT_KEY);
static OSD_ButtonSettings Key_Start(OSD_ButtonSettings::KEYBOARD_KEY, WIN32_DEFAULT_START_KEY);
static OSD_ButtonSettings Key_B(OSD_ButtonSettings::KEYBOARD_KEY, WIN32_DEFAULT_B_KEY);
static OSD_ButtonSettings Key_A(OSD_ButtonSettings::KEYBOARD_KEY, WIN32_DEFAULT_A_KEY);
static OSD_ButtonSettings Key_TB(OSD_ButtonSettings::KEYBOARD_KEY, WIN32_DEFAULT_TB_KEY); //NNN
static OSD_ButtonSettings Key_TA(OSD_ButtonSettings::KEYBOARD_KEY, WIN32_DEFAULT_TA_KEY);
static OSD_ButtonSettings Key_Extb1(OSD_ButtonSettings::KEYBOARD_KEY, WIN32_DEFAULT_EB1_KEY);
static OSD_ButtonSettings Key_Extb2(OSD_ButtonSettings::KEYBOARD_KEY, WIN32_DEFAULT_EB2_KEY);
static OSD_ButtonSettings Key_Extb3(OSD_ButtonSettings::KEYBOARD_KEY, WIN32_DEFAULT_EB3_KEY);
static OSD_ButtonSettings Key_Extb4(OSD_ButtonSettings::KEYBOARD_KEY, WIN32_DEFAULT_EB4_KEY);
static OSD_ButtonSettings Key_Extb5(OSD_ButtonSettings::KEYBOARD_KEY, WIN32_DEFAULT_EB5_KEY);
static OSD_ButtonSettings Key_Extb6(OSD_ButtonSettings::KEYBOARD_KEY, WIN32_DEFAULT_EB6_KEY);
static OSD_ButtonSettings Key_Extb7(OSD_ButtonSettings::KEYBOARD_KEY, WIN32_DEFAULT_EB7_KEY);
static OSD_ButtonSettings Key_Extb8(OSD_ButtonSettings::KEYBOARD_KEY, WIN32_DEFAULT_EB9_KEY);
static OSD_ButtonSettings Key_Extb9(OSD_ButtonSettings::KEYBOARD_KEY, WIN32_DEFAULT_EB9_KEY);
static OSD_ButtonSettings Key_Extb10(OSD_ButtonSettings::KEYBOARD_KEY, WIN32_DEFAULT_EB10_KEY);
static OSD_ButtonSettings Key_Extb11(OSD_ButtonSettings::KEYBOARD_KEY, WIN32_DEFAULT_EB11_KEY);
static OSD_ButtonSettings Key_Extb12(OSD_ButtonSettings::KEYBOARD_KEY, WIN32_DEFAULT_EB12_KEY);
static OSD_ButtonSettings Key_Extb13(OSD_ButtonSettings::KEYBOARD_KEY, WIN32_DEFAULT_EB13_KEY);
static OSD_ButtonSettings Key_Extb14(OSD_ButtonSettings::KEYBOARD_KEY, WIN32_DEFAULT_EB14_KEY);
static OSD_ButtonSettings Key_Extb15(OSD_ButtonSettings::KEYBOARD_KEY, WIN32_DEFAULT_EB15_KEY);
static OSD_ButtonSettings Key_Extb16(OSD_ButtonSettings::KEYBOARD_KEY, WIN32_DEFAULT_EB16_KEY);


static OSD_ButtonSettings Joystick_Button0(OSD_ButtonSettings::JOYSTICK_BUTTON, DIJOFS_BUTTON(0));
static OSD_ButtonSettings Joystick_Button1(OSD_ButtonSettings::JOYSTICK_BUTTON, DIJOFS_BUTTON(1));
static OSD_ButtonSettings Joystick_Button2(OSD_ButtonSettings::JOYSTICK_BUTTON, DIJOFS_BUTTON(2));
static OSD_ButtonSettings Joystick_Button3(OSD_ButtonSettings::JOYSTICK_BUTTON, DIJOFS_BUTTON(3));
static OSD_ButtonSettings Joystick_Button4(OSD_ButtonSettings::JOYSTICK_BUTTON, DIJOFS_BUTTON(4)); //NNN
static OSD_ButtonSettings Joystick_Button5(OSD_ButtonSettings::JOYSTICK_BUTTON, DIJOFS_BUTTON(5));

static OSD_ButtonSettings Joystick_AxisXp(OSD_ButtonSettings::JOYSTICK_AXIS, DIJOFS_X, 1);
static OSD_ButtonSettings Joystick_AxisXn(OSD_ButtonSettings::JOYSTICK_AXIS, DIJOFS_X, 0);
static OSD_ButtonSettings Joystick_AxisYp(OSD_ButtonSettings::JOYSTICK_AXIS, DIJOFS_Y, 1);
static OSD_ButtonSettings Joystick_AxisYn(OSD_ButtonSettings::JOYSTICK_AXIS, DIJOFS_Y, 0);

OSD_ButtonSettings* defaultUpSettings[] =
{
  &Key_Up,
  &Joystick_AxisYn,
  &Joystick_Button0,
  NULL
};

OSD_ButtonSettings* defaultDownSettings[] =
{
  &Key_Down,
  &Joystick_AxisYp,
  &Joystick_Button0,
  NULL
};

OSD_ButtonSettings* defaultLeftSettings[] =
{
  &Key_Left,
  &Joystick_AxisXn,
  &Joystick_Button0,
  NULL
};

OSD_ButtonSettings* defaultRightSettings[] =
{
  &Key_Right,
  &Joystick_AxisXp,
  &Joystick_Button0,
  NULL
};

OSD_ButtonSettings* defaultSelectSettings[] =
{
  &Key_Select,
  &Joystick_Button3,
  &Joystick_Button2,
  &Joystick_Button1,
  &Joystick_Button0,
  NULL
};

OSD_ButtonSettings* defaultStartSettings[] =
{
  &Key_Start,
  &Joystick_Button2,
  &Joystick_Button1,
  &Joystick_Button0,
  NULL
};

OSD_ButtonSettings* defaultBSettings[] =
{
  &Key_B,
  &Joystick_Button0,
  NULL
};

OSD_ButtonSettings* defaultASettings[] =
{
  &Key_A,
  &Joystick_Button1,
  &Joystick_Button0,
  NULL
};

	//NNN 
OSD_ButtonSettings* defaultTBSettings[] =
{
  &Key_TB,
  &Joystick_Button4,
  NULL
};

OSD_ButtonSettings* defaultTASettings[] =
{
  &Key_TA,
  &Joystick_Button5,
  NULL
};


OSD_ButtonSettings* defaultExtButton1Settings[] =
{
  &Key_Extb1,
  &Joystick_Button0,
  NULL
};

OSD_ButtonSettings* defaultExtButton2Settings[] =
{
  &Key_Extb2,
  &Joystick_Button0,
  NULL
};

OSD_ButtonSettings* defaultExtButton3Settings[] =
{
  &Joystick_Button0,
  NULL
};

OSD_ButtonSettings* defaultExtButton4Settings[] =
{
  &Joystick_Button0,
  NULL
};

OSD_ButtonSettings* defaultExtButton5Settings[] =
{
  &Joystick_Button0,
  NULL
};

OSD_ButtonSettings* defaultExtButton6Settings[] =
{
  &Key_Extb6,
  &Joystick_Button0,
  NULL
};

OSD_ButtonSettings* defaultExtButton7Settings[] =
{
  &Key_Extb7,
  &Joystick_Button0,
  NULL
};

OSD_ButtonSettings* defaultExtButton8Settings[] =
{
  &Joystick_Button0,
  NULL
};

OSD_ButtonSettings* defaultExtButton9Settings[] =
{
  &Joystick_Button0,
  NULL
};

OSD_ButtonSettings* defaultExtButton10Settings[] =
{
  &Joystick_Button0,
  NULL
};


OSD_ButtonSettings* defaultExtButton11Settings[] =
{
  &Key_Extb11,
  &Joystick_Button0,
  NULL
};


OSD_ButtonSettings* defaultExtButton12Settings[] =
{
  &Key_Extb12,
  &Joystick_Button0,
  NULL
};


OSD_ButtonSettings* defaultExtButton13Settings[] =
{
  &Key_Extb13,
  &Joystick_Button0,
  NULL
};


OSD_ButtonSettings* defaultExtButton14Settings[] =
{
  &Key_Extb14,
  &Joystick_Button0,
  NULL
};


OSD_ButtonSettings* defaultExtButton15Settings[] =
{
  &Key_Extb15,
  &Joystick_Button0,
  NULL
};


OSD_ButtonSettings* defaultExtButton16Settings[] =
{
  &Key_Extb16,
  &Joystick_Button0,
  NULL
};


