/*
** nester - NES emulator
** Copyright (C) 2000  Darren Ranalli
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful, 
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU 
** Library General Public License for more details.  To obtain a 
** copy of the GNU Library General Public License, write to the Free 
** Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
**
** Any permitted reproduction of these routines, in whole or in part,
** must bear this legend.
*/

#ifndef _WIN32_DEFAULT_CONTROLS_H_
#define _WIN32_DEFAULT_CONTROLS_H_

#include "OSD_ButtonSettings.h"
#include <dinput.h>

#define WIN32_DEFAULT_UP_KEY      DIK_UP
#define WIN32_DEFAULT_DOWN_KEY    DIK_DOWN
#define WIN32_DEFAULT_LEFT_KEY    DIK_LEFT
#define WIN32_DEFAULT_RIGHT_KEY   DIK_RIGHT
#define WIN32_DEFAULT_SELECT_KEY  DIK_Q
#define WIN32_DEFAULT_START_KEY   DIK_S
#define WIN32_DEFAULT_B_KEY       DIK_Z
#define WIN32_DEFAULT_A_KEY       DIK_X
#define WIN32_DEFAULT_TB_KEY      DIK_F				//nnn
#define WIN32_DEFAULT_TA_KEY      DIK_G
#define WIN32_DEFAULT_EB1_KEY     DIK_F12
#define WIN32_DEFAULT_EB2_KEY     DIK_F11
#define WIN32_DEFAULT_EB3_KEY     DIK_E
#define WIN32_DEFAULT_EB4_KEY     DIK_E
#define WIN32_DEFAULT_EB5_KEY     DIK_F5
#define WIN32_DEFAULT_EB6_KEY     DIK_F7
#define WIN32_DEFAULT_EB7_KEY     DIK_E
#define WIN32_DEFAULT_EB8_KEY     DIK_E
#define WIN32_DEFAULT_EB9_KEY     DIK_E
#define WIN32_DEFAULT_EB10_KEY     DIK_E
#define WIN32_DEFAULT_EB11_KEY     DIK_E
#define WIN32_DEFAULT_EB12_KEY     DIK_A
#define WIN32_DEFAULT_EB13_KEY     DIK_B
#define WIN32_DEFAULT_EB14_KEY     DIK_C
#define WIN32_DEFAULT_EB15_KEY     DIK_D
#define WIN32_DEFAULT_EB16_KEY     DIK_E

// lists (NULL-terminated arrays) of ptrs to OSD_ButtonSettings structs
// holding default input settings
extern OSD_ButtonSettings* defaultUpSettings[];
extern OSD_ButtonSettings* defaultDownSettings[];
extern OSD_ButtonSettings* defaultLeftSettings[];
extern OSD_ButtonSettings* defaultRightSettings[];
extern OSD_ButtonSettings* defaultSelectSettings[];
extern OSD_ButtonSettings* defaultStartSettings[];
extern OSD_ButtonSettings* defaultBSettings[];
extern OSD_ButtonSettings* defaultASettings[];
extern OSD_ButtonSettings* defaultTBSettings[];		//nnn
extern OSD_ButtonSettings* defaultTASettings[];
extern OSD_ButtonSettings* defaultExtButton1Settings[];
extern OSD_ButtonSettings* defaultExtButton2Settings[];
extern OSD_ButtonSettings* defaultExtButton3Settings[];
extern OSD_ButtonSettings* defaultExtButton4Settings[];
extern OSD_ButtonSettings* defaultExtButton5Settings[];
extern OSD_ButtonSettings* defaultExtButton6Settings[];
extern OSD_ButtonSettings* defaultExtButton7Settings[];
extern OSD_ButtonSettings* defaultExtButton8Settings[];
extern OSD_ButtonSettings* defaultExtButton9Settings[];
extern OSD_ButtonSettings* defaultExtButton10Settings[];
extern OSD_ButtonSettings* defaultExtButton11Settings[];
extern OSD_ButtonSettings* defaultExtButton12Settings[];
extern OSD_ButtonSettings* defaultExtButton13Settings[];
extern OSD_ButtonSettings* defaultExtButton14Settings[];
extern OSD_ButtonSettings* defaultExtButton15Settings[];
extern OSD_ButtonSettings* defaultExtButton16Settings[];

#endif
