

#include "windows.h"
#include "nnnkaillera.h"


HMODULE nnnkailleradll=NULL;

BOOL nnnkailleraInit(){
	void (WINAPI *Init)(VOID);
	if(!(nnnkailleradll=LoadLibrary("kailleraclient")))
		return FALSE;
	if(Init = (void(WINAPI *)(VOID))GetProcAddress(nnnkailleradll, (LPCSTR)"_kailleraInit@0")){
		Init();
	}
	return TRUE;
}


void nnnkailleraShutdown(){
	void (WINAPI *Shutdown)(VOID);
	if(nnnkailleradll){
		if(Shutdown = (void(WINAPI *)(VOID))GetProcAddress(nnnkailleradll, (LPCSTR)"_kailleraShutdown@0")){
			Shutdown();
		}
		FreeLibrary(nnnkailleradll);
		nnnkailleradll=NULL;
	}
	return;
}


void nnnkailleraSetInfos(kailleraInfos *kInfo){
	void (WINAPI *SetInfos)(kailleraInfos *);
	if(nnnkailleradll){
		if(SetInfos = (void(WINAPI *)(kailleraInfos *))GetProcAddress(nnnkailleradll, (LPCSTR)"_kailleraSetInfos@4")){
			SetInfos(kInfo);
		}
	}
	return;
}


void nnnkailleraSelectServerDialog(HWND hwnd){
	void (WINAPI *SelectServer)(HWND );
	if(nnnkailleradll){
		if(SelectServer = (void(WINAPI *)(HWND ))GetProcAddress(nnnkailleradll, (LPCSTR)"_kailleraSelectServerDialog@4")){
			SelectServer(hwnd);
		}
	}
	return;
}


int nnnkailleraModifyPlayValues(void *values, int size){
	int (WINAPI *ModifyPlay)(void *, int );
	if(nnnkailleradll){
		if(ModifyPlay = (int(WINAPI *)(void *, int ))GetProcAddress(nnnkailleradll, (LPCSTR)"_kailleraModifyPlayValues@8")){
			return ModifyPlay(values, size);
		}
	}
	return -1;
}


void nnnkailleraEndGame(){
	int (WINAPI *EndGame)();
	if(nnnkailleradll){
		if(EndGame = (int(WINAPI *)())GetProcAddress(nnnkailleradll, (LPCSTR)"_kailleraEndGame@0")){
			EndGame();
		}
	}
	return;
}


/*
_kailleraGetVersion@4
kailleraGetVersion(char *version);
_kailleraChatSend@4
kailleraChatSend(char *text);
*/

